/* Stampa i bit di una espressione int*/
#include <limits.h>
#include <stdio.h>
void bit_print(int a){
	int i;
	int n=sizeof(int) * CHAR_BIT; // In limits.h (number of bits in a int)
	int mask = (1 << (n-1)); // mask = 100...0
	for(i=1; i<=n; i++){
		putchar(((a & mask)==0) ? '0' : '1'); // Print the most significative bit (on the left) of a
		a  <<= 1;	// Shift a to the left
		if(i % CHAR_BIT == 0 && i<n)
			putchar (' ');
	}
}



int main(void){
	// Stampa numeri da 0 a 9 in rappresentazione binaria
	int i;
	for(i=0; i<10; ++i){	
		printf("%d: ", i);
		bit_print(i);
		putchar ('\n');
	}
	printf("\n\n");

	// Operatori binari logici bit a bit
	int a=33333;
	int b= -77777;
	
	printf("a: %d ,", a);
	bit_print(a);
	putchar ('\n');

	printf("b: %d, ", b);
	bit_print(b);
	putchar ('\n');

	printf("a&b: %d, ", a&b);
	bit_print(a&b);
	putchar ('\n');

	printf("a^b: %d, ", a^b);
	bit_print(a^b);
	putchar ('\n');

	printf("a | b: %d, ", a|b);
	bit_print(a|b);
	putchar ('\n');

	printf("~(a | b): %d, ", ~(a | b));
	bit_print(~(a | b));
	putchar ('\n');

	printf("(~a & ~b): %d, ", (~a & ~b));
	bit_print((~a & ~b));
	putchar ('\n');putchar ('\n');

	// Operatori di scorrimento
	char c='Z'; 	// Integer=90=64+16+8+2
	printf("c: %d, ", c);
	bit_print(c);
	putchar ('\n');

	printf("c<<1: %d, ", c<<1);
	bit_print(c<<1);
	putchar ('\n');

	printf("c<<4: %d, ", c<<4);
	bit_print(c<<4);
	putchar ('\n');

	printf("c<<31: %d, ", c<<31);
	bit_print(c<<31);
	putchar ('\n');

	int d=(1<<31);
	unsigned e=(1<<31);

	printf("d: %d, ", d);
	bit_print(d);
	putchar ('\n');

	printf("d>>3: %d, ", d>>3);
	bit_print(d>>3);
	putchar ('\n');

	printf("e: %u, ", e);
	bit_print(e);
	putchar ('\n');

	printf("e>>3: %d, ", e>>3);
	bit_print(e>>3);
	putchar ('\n');

	return 0;
}

// gcc bit_print.c -o bit_print
// ./bit_print
